<template>
  <div>
    <el-dialog :title="props.title" width="1000px" v-model="props.addDiaShow" :before-close="handleClose">
      <!-- 培训计划新增或修改 -->
      <div class="config">
        <el-form ref="ruleFormRef" :model="ruleForm" :rules="rules" label-width="150px" class="demo-ruleForm.value"
          :disabled='!saveBtnShow' style="width: 100% !important;">
          <el-form-item label="学习驾驶开始时间：" prop="begindate">
            <!-- :disabled-date="disablednowDate" -->
            <el-date-picker v-model="ruleForm.begindate" style="width: 100%" type="date" format="YYYY-MM-DD"
              value-format="YYYY-MM-DD" @change="changexxks" />
          </el-form-item>
          <el-form-item label="学习驾驶结束时间：" prop="enddate">
            <!-- :disabled-date="disabledjsjs" -->
            <el-date-picker v-model="ruleForm.enddate" style="width: 100%" type="date" format="YYYY-MM-DD"
              value-format="YYYY-MM-DD" />
          </el-form-item>
          <el-form-item label="所在单位：" prop="location">
            <el-input v-model="ruleForm.location" clearable style="width: 100%"></el-input>
          </el-form-item>
          <el-form-item label="干何工作：" prop="work">
            <el-input v-model="ruleForm.work" clearable style="width: 100%"></el-input>
          </el-form-item>
          <el-form-item label="证明人：" prop="certifier">
            <el-input v-model="ruleForm.certifier" clearable style="width: 100%"></el-input>
          </el-form-item>
        </el-form>
      </div>
      <template #footer>
        <span class="dialog-footer">
          <el-button type="primary" :loading="loading" @click="handleSave(ruleFormRef)" v-if="saveBtnShow">
            <el-icon>
              <DocumentChecked />
            </el-icon>
            <span>保存</span>
          </el-button>
          <el-button @click="handleClose" type="primary">
            <el-icon>
              <DocumentDelete />
            </el-icon>
            <span>关闭</span>
          </el-button>
        </span>
      </template>
    </el-dialog>
  </div>
</template>

<script setup>
// 引入
import {
  ref,
  onMounted,
  defineProps,
  defineEmits,
  reactive,
  getCurrentInstance,
  watchEffect
} from "vue";
import { disablednowDate } from '@/utils/tools.js'
import { ElMessage } from "element-plus";
import { postApi } from "@/api/tobAcco_api.js";
const { proxy } = getCurrentInstance();
//表单数据
const ruleFormRef = ref()
const loading = ref(false)
const ruleForm = ref({
});
//规则校验
const rules = reactive({
  begindate: [{ required: true, message: "学习驾驶开始时间不能为空", trigger: "blur" }],
  enddate: [{ required: true, message: "学习驾驶结束时间不能为空", trigger: "blur" }],
  location: [{ required: true, message: "所在单位不能为空", trigger: "blur" }],
  work: [{ required: true, message: "干何工作不能为空", trigger: "blur" }],
  certifier: [{ required: true, message: "证明人不能为空", trigger: "blur" }],
});
const props = defineProps({
  addDiaShow: {
    type: Boolean,
    default: false
  },
  rowxq: {
    type: Object,
    default: () => { }
  },
  title: String,
  saveBtnShow: {
    default: true,
    type: Boolean
  }
});

watchEffect(() => {
  if (props.rowxq) {
    ruleForm.value = JSON.parse(JSON.stringify(props.rowxq));
  } else {
    ruleForm.value = {}
  }
});
const emits = defineEmits(["changeAddVi", "changeclose"]);

onMounted(() => { });

function disabledjsjs(time) {
  return time.getTime() + 24 * 60 * 60 * 1000 < new Date(ruleForm.value.begindate).getTime() || time.getTime() > Date.now()
}
function changexxks(params) {
  ruleForm.value.enddate = '';
}

// 关闭
const handleClose = () => {
  if (props.saveBtnShow) {
    proxy.$modal.confirm('离开会丢失页面中修改的内容，确认离开吗？')
      .then(() => {
        emits("changeclose", false);
      })
      .catch(() => {
        // catch error
      })
  } else {
    emits("changeclose", false);
  }

};

// 关闭×
const closeDialog = () => {
  emits("changeclose", false);
};
// 保存
const handleSave = async (ruleFormRef) => {
  loading.value = true
  if (!ruleFormRef) return;
  await ruleFormRef.validate((valid) => {
    if (valid) {
      if (ruleForm.value) {
        if (ruleForm.value.id) {
          postApi(ruleForm.value, "/mosty-jcgl/driverWadc/updateDriverWadc")
            .then(() => {
              ElMessage.success("修改成功");
              emits("changeclose", false);
              emits("changeAddVi", ruleForm.value);
              loading.value = false
            }).catch((err) => {
              loading.value = false
            })
        } else {
          emits("changeAddVi", ruleForm.value);
          loading.value = false
          emits("changeclose", false);
        }
      }
    } else {
      ElMessage.error("请输入必填项!");
      loading.value = false
    }
  });

};
</script>

<style lang="scss" scoped>
.fj {
  .el-form {
    padding: 10px;
    margin-top: 10px;
    flex-wrap: wrap;
    // width: 1170px;
    justify-content: flex-end;
  }

  .from_fix {
    display: flex;
    flex-wrap: wrap;
    padding: 10px;
    margin-top: 10px;

    // .el-form-item--default .el-form-item__content {
    //   flex-wrap: nowrap !important;
    // }

    .el-input {
      width: 100%;
    }
  }
}

::v-deep .el-form-item__content {
  flex-wrap: nowrap !important;
}

.config {
  width: 955px;

  .el-form {
    width: 100% !important;
    padding: 10px 40px;
    margin-top: 10px;
    flex-wrap: wrap;
    justify-content: space-between;
  }

  .el-form-item {
    width: 46%;
    text-align: center;
  }
}

.pxdx_box {
  width: 500px;
}

.titleBox {
  align-items: center;
  margin: 0;
  padding: 0;
  height: 60px;
  border: 1px solid rgb(32, 75, 54);
  padding: 20px;
}

.form>div {
  position: relative;
  margin-top: 30px;
  display: flex;
  justify-content: space-between;

  div {
    display: flex;
    align-items: center;

    .el-select {
      width: 65%;
    }
  }
}

.el-input {
  width: 75%;
}

.two .el-input {
  width: 65%;
}

.three {
  justify-content: flex-start !important;

  .el-select {
    width: 15%;
  }
}

.four {
  display: flex;
  align-items: center;

  span {
    width: 5%;
  }

  .el-textarea__inner {
    width: 95%;
  }
}

.group {
  margin-top: 50px;
  // background-color: red;
  position: relative;
}

.fj {
  margin-top: 50px;
  width: 100%;

  .content {
    width: 100%;
    display: flex;
    padding: 20px;

    div {
      display: flex;
      width: 85%;
      align-items: center;
    }

    justify-content: space-between;
  }
}

.jc {
  margin-top: 50px;
}

.tabBox {
  height: 300px !important;
}

.el-table {
  height: 300px !important;
  border: 1px solid var(--el-color-primary);
}

.el-form-item__content {
  flex-wrap: nowrap;
}
</style>